<template>
  <div
    class="bg-warning-500 bg-opacity-30 rounded border border-warning-600 flex flex-col gap-2 p-2"
  >
    <textarea
      :value="hindrance.description"
      disabled
      class="rounded border border-warning-600 p-1 bg-primary-900"
    />
    <div class="flex flex-row justify-around gap-2">
      <span
        class="rounded border border-warning-600 p-1 bg-primary-900 text-sm"
        >{{ project.name() }}</span
      >
      <span
        class="rounded border border-warning-600 p-1 bg-primary-900 text-sm"
        >{{ workCategory.name() }}</span
      >
    </div>
    <div class="flex flex-row justify-around gap-2">
      <span v-if="!user">Carregando</span>
      <span
        v-else
        class="rounded border border-warning-600 p-1 bg-primary-900 text-sm"
        >{{ user.name }}</span
      >
      <span
        class="rounded border border-warning-600 p-1 bg-primary-900 text-sm"
        >{{
          new Date(hindrance.createdAt()).toLocaleString().split(' ')[0]
        }}</span
      >
    </div>
  </div>
</template>

<script>
import { getAxiosHeaders } from '~/utils/utils'
import Hindrance from '~/classes/Hindrance'
import User from '~/classes/User'
export default {
  name: 'HindranceCard',
  props: {
    hindrance: Hindrance,
  },
  data() {
    return {
      user: null,
    }
  },
  computed: {
    project() {
      return this.$store.getters['projects/getProjectById'](
        this.hindrance.projectId
      )
    },
    workCategory() {
      return this.$store.getters['workCategories/getWorkCategoryById'](
        this.hindrance.workCategory
      )
    },
  },
  mounted() {
    try {
      this.$axios
        .$get(
          `getUserById/${this.hindrance.userId}`,
          getAxiosHeaders(this.$auth)
        )
        .then((response) => {
          if (response.status.is_error) {
            return this.$toast.error(
              'Ocorreu um erro ao carregar usuário pelo id, contate um administrador.',
              {
                closeOnSwipe: true,
                duration: 3000,
              }
            )
          }
          this.user = new User(response.data.user)
        })
    } catch (error) {
      // eslint-disable-next-line no-console
      console.warn(error)
      this.$toast.error('Ocorreu um erro inesperado...', {
        closeOnSwipe: true,
        duration: 2000,
      })
    }
  },
}
</script>
